/*
Simple HTTP client from Harry Fairhead 
Master the Raspberry Pi Pico in C: WiFi with lwIP & mbedtls
IO Press, 2023, page 42
*/

#include <stdio.h>
#include "pico/stdlib.h"
#include "pico/cyw43_arch.h"
#include "setupWifi.h"
#include "lwip/tcp.h"

bool page_done ;
#define BUF_SIZE 2048
char myBuff[BUF_SIZE];
char header[] = "GET /ledtest?led=1&test=100&test2=90 HTTP/1.1\r\n\r\n "; //HOST:192.168.4.1\r\nConnection: close\r\n\r\n";
//char header[] = "GET /ledtest HTTP/1.1\r\n\r\n ";

err_t recv(void *arg, struct tcp_pcb *pcb, struct pbuf *p, err_t err)
{
 if (p != NULL)
 {
 printf("recv total %d  this buffer %d next %d err %d\n", p->tot_len, p->len, p->next, err);
 pbuf_copy_partial(p, myBuff, p->tot_len, 0);
 myBuff[p->tot_len] = 0;
 printf("Buffer= %s\n", myBuff);
 tcp_recved(pcb, p->tot_len);
 pbuf_free(p);
 page_done = true;
 }
 //   int32_t rssi ;
 //   cyw43_wifi_get_rssi (&cyw43_state, &rssi);
 //   printf("rssi=%d\n\r", rssi) ;
    return ERR_OK;
}

static err_t connected(void *arg, struct tcp_pcb *pcb, err_t err)
{
 err = tcp_write(pcb, header, strlen(header), 0);
 //if(err == ERR_OK) printf("err OK write\r\n");
 err = tcp_output(pcb);
 return ERR_OK;
}

int main()
{

    int led_state ;
    
    stdio_init_all();
    connect();

    struct tcp_pcb *pcb = tcp_new();
    //struct tcp_pcb *pcb_b = tcp_new();
    //memcpy(&pcb_b, &pcb, sizeof(pcb));
    tcp_recv(pcb, recv);
    ip_addr_t ip;
    IP4_ADDR(&ip, 192, 168, 4, 1);
    cyw43_arch_lwip_begin();
    err_t err = tcp_connect(pcb, &ip, 80, connected);
    cyw43_arch_lwip_end();

    while (true)
    { 
        
        //sleep_ms(2000);
        while(!page_done) {};
        page_done = false;
        
        printf("cmd>");
        scanf("%d", &led_state);
        // header[] = "GET /ledtest?led=1&test=100&test2=90 HTTP/1.1\r\n\r\n ";
        if (led_state) sprintf(header,"%s", "GET /ledtest?led=1&test=100&test2=90 HTTP/1.1\r\n\r\n ") ;
        else sprintf(header,"%s", "GET /ledtest?led=0&test=100&test2=90 HTTP/1.1\r\n\r\n ") ;

        tcp_abort(pcb) ;

        struct tcp_pcb *pcb = tcp_new();
        tcp_recv(pcb, recv);
        //(pcb)->state = CLOSED;
        //tcp_close(pcb);
        //free(pcb);
        //pcb = NULL ;
       //pcb = tcp_new();
        //tcp_recv(pcb, recv);
      // pcb = NULL ;
      //tcp_close(pcb);
       //memcpy(pcb, pcb_b, sizeof(pcb_b));
       
        //pcb = tcp_new();
       // memcpy(&pcb, &pcb_b, sizeof(pcb_b));
        //tcp_recv(pcb, recv);
        cyw43_arch_lwip_begin();
        err_t err = tcp_connect(pcb, &ip, 80, connected);
        cyw43_arch_lwip_end();

    }
}
